GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | List of all members
TPG::TPGInstrumentedFactory Class Reference

`#include <tpgInstrumentedFactory.h>`

Inheritance diagram for TPG::TPGInstrumentedFactory:

## Public Member Functions
virtual std::shared_ptr< TPGGraph > | createTPGGraph (const Environment &env) const override
virtual std::unique_ptr< TPGTeam > | createTPGTeam () const override
| Specialization of the method returning a TPGTeamInstrumented.
virtual std::unique_ptr< TPGAction > | createTPGAction (const uint64_t id) const override
| Specialization of the method returning a TPGActionInstrumented.
virtual std::unique_ptr< TPGEdge > | createTPGEdge (const TPGVertex *src, const TPGVertex *dest, const std::shared_ptr< Program::Program > prog) const override
| Specialization of the method returning a TPGEdgeInstrumented.
virtual std::unique_ptr< TPGExecutionEngine > | createTPGExecutionEngine (const Environment &env, Archive *arch=NULL) const override
void | resetTPGGraphCounters (const TPG::TPGGraph &tpg) const
| Reset all visit and traversal counters of a TPGGraph.
void | clearUnusedTPGGraphElements (TPG::TPGGraph &tpg) const
| Removes from the TPGGraph the vertices and edges that were never visited (since the last reset).
Public Member Functions inherited from TPG::TPGFactory
virtual | ~TPGFactory ()=default
| Default virtual destructor.
virtual std::unique_ptr< TPGEdge > | createTPGActionEdge (const TPGVertex *src, const std::shared_ptr< Program::Program > prog, uint64_t actionClass) const
| Create a TPGActionEdge for a TPGGraph.

## Detailed Description

Specialization of the TPGFactory class producing TPGTeamInstrumented, TPGActionInstrumented, TPGEdgeInstrumented, and TPGExecutionEngineInstrumented

Also contains a helper function for resetting the instrumentation of a TPGGraph.

## Member Function Documentation

## ◆ clearUnusedTPGGraphElements()

void TPG::TPGInstrumentedFactory::clearUnusedTPGGraphElements | ( | TPG::TPGGraph & | tpg | ) | const

Removes from the TPGGraph the vertices and edges that were never visited (since the last reset).

This method removes from the TPGGraph:

- The TPGVertex with a number of visit equal to zero.
- The TPGEdge with a number of traversal equal to zero.

The method will do nothing on a TPGGraph whose TPGVertex and TPGEdge are not TPGVertexInstrumentation and TPGEdgeInstrumented specializations.

Beware, this function may remove TPGAction from the TPGGraph, thus making it improper for future training.

Parameters

  [in] | tpg | Reference to the TPGGraph whose TPGVertexInstrumentation and TPGEdge will be removed.

## ◆ createTPGAction()

std::unique_ptr< TPG::TPGAction > TPG::TPGInstrumentedFactory::createTPGAction | ( | const uint64_t | id | ) | const
| override virtual

Specialization of the method returning a TPGActionInstrumented.

Reimplemented from TPG::TPGFactory.

## ◆ createTPGEdge()

std::unique_ptr< TPG::TPGEdge > TPG::TPGInstrumentedFactory::createTPGEdge | ( | const TPGVertex * | src,
|  | const TPGVertex * | dest,
|  | const std::shared_ptr< Program::Program > | prog ) const
| override virtual

Specialization of the method returning a TPGEdgeInstrumented.

Reimplemented from TPG::TPGFactory.

## ◆ createTPGExecutionEngine()

std::unique_ptr< TPG::TPGExecutionEngine > TPG::TPGInstrumentedFactory::createTPGExecutionEngine | ( | const Environment & | env,
|  | Archive * | arch = NULL ) const
| override virtual

Specialization of the method returning a TPGExecutionEngineInstrumented

Reimplemented from TPG::TPGFactory.

## ◆ createTPGGraph()

std::shared_ptr< TPG::TPGGraph > TPG::TPGInstrumentedFactory::createTPGGraph | ( | const Environment & | env | ) | const
| override virtual

Specialization of the method returing the TPGGraph with a TPGInstrumentedFactory as an attribute.

Copyright or © or Copr. IETR/INSA - Rennes (2022) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2022)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

Reimplemented from TPG::TPGFactory.

## ◆ createTPGTeam()

std::unique_ptr< TPG::TPGTeam > TPG::TPGInstrumentedFactory::createTPGTeam | ( |  | ) | const
| override virtual

Specialization of the method returning a TPGTeamInstrumented.

Reimplemented from TPG::TPGFactory.

## ◆ resetTPGGraphCounters()

void TPG::TPGInstrumentedFactory::resetTPGGraphCounters | ( | const TPG::TPGGraph & | tpg | ) | const

Reset all visit and traversal counters of a TPGGraph.

Parameters

  [in] | tpg | the TPGGraph whose TPGTeamInstrumented, TPGActionInstrumented, and TPGEdgeInstrumented will be reseted.The TPGGraph is const since all instrumentation counters are mutable.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/tpg/instrumented/tpgInstrumentedFactory.h
- D:/a/gegelati/gegelati/gegelatilib/src/tpg/instrumented/tpgInstrumentedFactory.cpp